"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ColorPicker = _interopRequireDefault(require("./ColorPicker"));

var _styleContainer = require("@cloudflare/style-container");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var CoverDiv = (0, _styleContainer.createComponent)(function () {
  return {
    position: 'fixed',
    top: '0px',
    right: '0px',
    bottom: '0px',
    left: '0px'
  };
}, 'div');
var PopoverDiv = (0, _styleContainer.createComponent)(function () {
  return {
    position: 'absolute',
    zIndex: '2'
  };
}, 'div');
var FakeInputDiv = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme,
      disabled = _ref.disabled;
  return {
    zIndex: 0,
    width: '100%',
    height: '2.26667rem',
    margin: '0 0 0.75rem',
    padding: '.6em .9em',
    borderBottom: "1px solid ".concat(theme.colors.gray[5]),
    borderTop: "1px solid ".concat(theme.colors.gray[5]),
    borderLeft: "1px solid ".concat(theme.colors.gray[5]),
    borderRight: "1px solid ".concat(theme.colors.gray[5]),
    borderRadius: '2px',
    flex: 'initial',
    verticalAlign: 'middle',
    fontFamily: theme.fontFamily,
    fontSize: '0.86667rem',
    background: theme.colors.background,
    color: theme.colors.gray[1],
    outline: 'none',
    transition: 'border-color 0.2s ease',
    textIndent: 'initial',
    '&:hover': {
      borderColor: disabled ? null : theme.colors.blue[4]
    },
    '&:disabled': {
      background: theme.colors.background,
      color: theme.colors.gray[1]
    }
  };
}, 'div');
var ColorDisplayDiv = (0, _styleContainer.createComponent)(function (_ref2) {
  var theme = _ref2.theme,
      color = _ref2.color,
      defaultColor = _ref2.defaultColor;
  return {
    background: color || defaultColor,
    height: '100%',
    width: '100%',
    borderWidth: '1px',
    borderStyle: 'solid',
    borderColor: theme.colors.gray[5]
  };
}, 'div');

var ColorPickerInput = /*#__PURE__*/function (_React$Component) {
  _inherits(ColorPickerInput, _React$Component);

  var _super = _createSuper(ColorPickerInput);

  function ColorPickerInput(props) {
    var _this;

    _classCallCheck(this, ColorPickerInput);

    _this = _super.call(this, props);
    _this.state = {
      displayColorPicker: false
    };
    _this.handleChange = _this.handleChange.bind(_assertThisInitialized(_this));
    _this.handleClose = _this.handleClose.bind(_assertThisInitialized(_this));
    _this.handleClick = _this.handleClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ColorPickerInput, [{
    key: "handleClick",
    value: function handleClick(e) {
      e.preventDefault();
      this.setState({
        displayColorPicker: !this.state.displayColorPicker
      });
    }
  }, {
    key: "handleClose",
    value: function handleClose() {
      this.setState({
        displayColorPicker: false
      });
    }
  }, {
    key: "handleChange",
    value: function handleChange(color) {
      this.props.onChange({
        value: color.hex
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          defaultEmptyValue = _this$props.defaultEmptyValue,
          value = _this$props.value,
          disabled = _this$props.disabled;
      return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(FakeInputDiv, {
        onClick: disabled ? function () {
          return null;
        } : this.handleClick,
        disabled: disabled
      }, /*#__PURE__*/_react.default.createElement(ColorDisplayDiv, {
        color: value,
        defaultColor: defaultEmptyValue
      })), this.state.displayColorPicker ? /*#__PURE__*/_react.default.createElement(PopoverDiv, null, /*#__PURE__*/_react.default.createElement(CoverDiv, {
        onClick: this.handleClose
      }), /*#__PURE__*/_react.default.createElement(_ColorPicker.default, {
        color: value,
        onChange: disabled ? function () {
          return null;
        } : this.handleChange
      })) : null);
    }
  }]);

  return ColorPickerInput;
}(_react.default.Component);

ColorPickerInput.propTypes = {
  disabled: _propTypes.default.bool,
  defaultEmptyValue: _propTypes.default.string,
  onChange: _propTypes.default.func,
  value: _propTypes.default.string
};
var _default = ColorPickerInput;
exports.default = _default;